package org.one.stone.soup.server.smtp.dummy;

import java.net.Socket;
import java.util.Vector;

import org.one.stone.soup.server.PlainServer;
import org.one.stone.soup.server.RouterThread;

public class SmtpServer extends PlainServer {

	private Vector sessions = new Vector();
	private String root;
	
	public String getRoot() {
		return root;
	}

	public static void main(String[] args)
	{
		if(args.length!=3)
		{
			System.out.println("Usage: SmtpServer address port storeDirectory");
			return;
		}
		
		SmtpServer smtpServer = new SmtpServer();
		smtpServer.setRoot(args[2]);
		smtpServer.start("Dummy Smtp Server", args[0], Integer.parseInt(args[1]), 10, 1000);
	}
	
	public void initialize() {
	}

	private void setRoot(String root) {
		this.root = root;
	}

	public void route(Socket socket, RouterThread router) {
		
		router.stopTimer();
		
		try{
			SmtpSession session = new SmtpSession(this,socket);
			sessions.add(session);
			System.out.println("Smtp Session "+session+" Started");
			session.start();
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
	}

	public void remove(SmtpSession session)
	{
		sessions.remove(session);
		System.out.println("Smtp Session "+session+" Stopped");
	}
}
