package test.org.one.stone.soup.file;

import org.one.stone.soup.file.FileDifferenceEngine;

import junit.framework.TestCase;

public class FileDifferenceEngineTest extends TestCase {
	
	public void testDoesMarkMixedChanges()
	{
		String textA =
			"a\n"+
			"c\n"+
			"d";
		
		String textB = 
			"a\n"+
			"b\n"+
			"c";
		
		String textResult = 
			"  a\n" +
			"- b\n" +
			"  c\n" +
			"+ d\n";
		
		String result = FileDifferenceEngine.getDifferences(textA,textB);
		
		assertEquals(textResult,result);
	}
	
	public void testDoesMarkAdditions()
	{
		String textA =
			"a\n"+
			"b\n"+
			"c\n" +
			"b\n"+
			"e";
		
		String textB = 
			"a\n"+
			"b\n"+
			"c";
		
		String textResult = 
			"  a\n" +
			"  b\n" +
			"  c\n" +
			"+ b\n" +
			"+ e\n";
		
		String result = FileDifferenceEngine.getDifferences(textA,textB);
		
		assertEquals(textResult,result);
	}
	
	public void testDoesMarkDeletions()
	{
		String textB =
			"a\n"+
			"b\n"+
			"c\n" +
			"b\n"+
			"e";
		
		String textA = 
			"a\n"+
			"b\n"+
			"c";
		
		String textResult = 
			"  a\n" +
			"  b\n" +
			"  c\n" +
			"- b\n" +
			"- e\n";
		
		String result = FileDifferenceEngine.getDifferences(textA,textB);
		
		assertEquals(textResult,result);
	}	
	
	public void testDoesIgnorTerminatingNewLine()
	{
		String textA =
			"a\r\n"+
			"b\r\n"+
			"c";
		
		String textB = 
			"a\r\n"+
			"b\r\n"+
			"c\r\n";
		
		String textResult = 
			"  a\n" +
			"  b\n" +
			"  c\n";
		
		String result = FileDifferenceEngine.getDifferences(textA,textB);
		
		assertEquals(textResult,result);
	}	
}
