package test.org.one.stone.soup.file;

import java.io.File;

import org.one.stone.soup.file.FileChangeListener;
import org.one.stone.soup.file.FileWatch;

import junit.framework.TestCase;

public class FileWatchTest extends TestCase {

	
	public void testTriggeredWhenFileChanges()
	{
		try{
			File file = File.createTempFile("file-watch","test");
			
			class FileWatcher implements FileChangeListener
			{
				public boolean changed = false;
				
				public boolean waitForChange(long time)
				{
					long count = time/10;
					while(count>0)
					{
						count--;
						if(changed)
						{
							return true;
						}
						try{ Thread.sleep(10);}catch(Exception e){}
					}
					return false;
				}
				
				public void fileChanged(File changedFile)
				{
					changed = true;
				}
			}
			FileWatcher listener = new FileWatcher();
			
			FileWatch fileWatch = new FileWatch(file.getAbsolutePath(),500);
			fileWatch.addListener( listener );
			
			file.setLastModified( file.lastModified()+1000 );
			
			boolean result = listener.waitForChange(1000);
			
			assertEquals(true,result);
		}
		catch(Exception e)
		{
			fail("Exception thrown: "+e);
		}
	}	
}
