package test.org.one.stone.soup.javahelper;

import org.one.stone.soup.javahelper.JavaNameHelper;

import junit.framework.TestCase;

public class JavaNameHelperTest extends TestCase {

	public String className = "SomeTestCaseTextIMHO";
	public String dataName = "someTestCaseTextIMHO";
	public String titleName = "Some Test Case Text IMHO";
	public String staticName = "SOME_TEST_CASE_TEXT_IMHO";
	
	public void testCanConvertClassToTitle()
	{
		String result = JavaNameHelper.classToTitleName(className);
		
		assertEquals(titleName,result);
	}
	public void testCanConvertDataToStatic()
	{
		String result = JavaNameHelper.dataToStaticName(dataName);
		
		assertEquals(staticName,result);		
	}
	public void testCanConvertDataToTitle()
	{
		String result = JavaNameHelper.dataToTitleName(dataName);
		
		assertEquals(titleName,result);		
	}
	public void testCanConvertStaticToTitle()
	{
		String titleName = "Some Test Case Text Imho"; // not enough information to keep IMHO
		
		String result = JavaNameHelper.staticToTitleName(staticName);
		
		assertEquals(titleName,result);	
	}
	public void testCanConvertTitleToClass()
	{
		String result = JavaNameHelper.titleToClassName(titleName);
		
		assertEquals(className,result);		
	}
	public void testCanConvertTitleToData()
	{
		String result = JavaNameHelper.titleToDataName(titleName);
		
		assertEquals(dataName,result);		
	}
	public void testCanConvertTitleToStatic()
	{
		String result = JavaNameHelper.titleToStaticName(titleName);
		
		assertEquals(staticName,result);		
	}
}
