package test.org.one.stone.soup.stringhelper;

import java.util.Hashtable;
import java.util.Vector;

import junit.framework.TestCase;

import org.one.stone.soup.stringhelper.StringGenerator;

public class StringGeneratorTests extends TestCase {

	public void testGenerateListForMaskWithDoubleStartCharacters()
	{
		String testData = "a b c\nd e f&123;\n&4;xz&5;y &&\nend &a bit&tag;";
		
		Vector list = StringGenerator.getListForMask(testData);
		
		assertEquals(4,list.size());
		assertEquals("123",(String)list.elementAt(0));
		assertEquals("4",(String)list.elementAt(1));
		assertEquals("5",(String)list.elementAt(2));
		assertEquals("tag",(String)list.elementAt(3));		
	}

	public void testGenerateStringWithMask()
	{
		String testData = "a b c\nd e f&123;\n&4;xz&5;y &pageName=&pageName;&fileName=&fileName; &&\nend &a bit&tag;&more";
		Hashtable list = new Hashtable();
		list.put("123","321");
		list.put("4","four");
		list.put("5","five");
		list.put("tag","TAG");
		list.put("fileName","FILE");
		list.put("pageName","PAGE");
		
		String result = StringGenerator.generateStringWithMask(testData,list);
		
		assertEquals( "a b c\nd e f&321;\nfourxzfivey &pageName=PAGE&fileName=FILE &&\nend &a bitTAG&more",result );		
	}
	
	public void testGenerateStringWithMaskWithUnusedEmbededCharacters()
	{	
		String testData = "<a href=\"/OpenForum/Actions/Delete?pageName=&pageName;&fileName=&fileName;\" title=\"Delete\"><img src=\"/OpenForum/Images/cancel.png\" border=\"0\" class=\"nodeImg\"></a>\"";
		Hashtable list = new Hashtable();

		list.put("fileName","FILE");
		list.put("pageName","PAGE");
		
		String result = StringGenerator.generateStringWithMask(testData,list);
		
		String happyPath = "<a href=\"/OpenForum/Actions/Delete?pageName=PAGE&fileName=FILE\" title=\"Delete\"><img src=\"/OpenForum/Images/cancel.png\" border=\"0\" class=\"nodeImg\"></a>\"";
		
		assertEquals( happyPath,result );		
	}
	
	public void testReplaceAndWithCat()
	{
		String testData = "The cat in the sand aaandy was red and blue";
		
		String result = StringGenerator.replace(testData,"and","cat");
		
		assertEquals("The cat in the scat aacaty was red cat blue",result);
	}
	
}
