package test.org.one.stone.soup.xml;

import org.one.stone.soup.xml.XmlElement;
import org.one.stone.soup.xml.XmlParseException;
import org.one.stone.soup.xml.XmlParser;

import junit.framework.TestCase;

public class XmlElementTest extends TestCase {

	public void testToXmlWithValueRenders()
	{
		String xml = "<data>a value</data>";
		
		XmlElement element = null;
		try{
			element = new XmlParser().parseElement(xml);
		}
		catch(XmlParseException xe)
		{
			fail(xe.getMessage());
		}
		
		assertEquals(xml,element.toXml());
	}
	
	public void testToXmlBeautifyWithValueRenders()
	{
		String xml = "<doc>\r\n\t<data>a value</data>\r\n</doc>";
		
		XmlElement element = null;
		try{
			element = new XmlParser().parseElement(xml);
		}
		catch(XmlParseException xe)
		{
			fail(xe.getMessage());
		}
		
		assertEquals(xml,element.toXml());
	}
	
	public void testToXmlWithMultipleChildrenRenders()
	{
		String xml = "<data>\r\n"+
						"\t<value>a</value>\r\n"+
						"\t<value>\r\n"+
							"\t\t<value value=\"b\"/>\r\n"+
							"\t\t<value>b</value>\r\n"+
						"\t</value>\r\n" +
					"</data>";
		
		/*String xml = "<table name=\"http-server\" cellPadding=\"4\" rowPadding=\"2\">"+
		"<tr>"+
		"<td colspan=\"2\" align=\"center\" valign=\"middle\">"+
		"<h face=\"Arial\" style=\"BOLD\" size=\"14\">Http Server</h>"+
		"</td>"+
		"</tr>"+
		"</table>";*/
		
		XmlElement element = null;
		try{
			element = new XmlParser().parseElement(xml);
		}
		catch(XmlParseException xe)
		{
			fail(xe.getMessage());
		}
		
		assertEquals(xml,element.toXml());
	}	
	
}
