package test.org.one.stone.soup.xml;

import org.one.stone.soup.xml.XmlDocument;
import org.one.stone.soup.xml.XmlParseException;
import org.one.stone.soup.xml.XmlParser;

import junit.framework.TestCase;

public class XmlParserCDATATests extends TestCase {

	public void testParserReadsCDATA()
	{
		String nonXmlData = " >some \" \n line2 \n line3 [text] in here '< ";
		String xmlData="<xml><cdata><![CDATA["+nonXmlData+"]]></cdata></xml>";
		
		XmlParser parser = new XmlParser();
		
		XmlDocument doc = null;
		try{
			doc = parser.parseDocument( xmlData );
		}
		catch(XmlParseException pex)
		{
			fail(pex.getMessage());
		}
		
		String result = doc.getElementByName("cdata").getValue();
		
		assertEquals("Failed to parse CDATA",nonXmlData,result);
	}
	
	public void testParserWritesCDATA()
	{
		String nonXmlData = " >some \" \n line2 \n line3 [text] in here '< ";
		String xmlData="<xml><cdata><![CDATA["+nonXmlData+"]]></cdata></xml>";		

		XmlParser parser = new XmlParser();
		
		XmlDocument doc = null;
		try{
			doc = parser.parseDocument( xmlData );
		}
		catch(XmlParseException pex)
		{
			fail(pex.getMessage());
		}

		String result = doc.toXmlNoBeautify();

		assertEquals("Failed to write CDATA",xmlData,result);
	}
}
