package test.org.one.stone.soup.xml;

import org.one.stone.soup.xml.XmlDOCTYPEParser;
import org.one.stone.soup.xml.XmlDocument;
import org.one.stone.soup.xml.XmlParseException;
import org.one.stone.soup.xml.XmlParser;

import junit.framework.TestCase;

public class XmlParserDOCTYPETests extends TestCase {

	public void testParserReadsDOCTYPE()
	{
		String xmlData="<!DOCTYPE project ["+
			"<!ENTITY global_properties SYSTEM \"file:global_properties.xml\">"+
			"<!ENTITY global_classpaths SYSTEM \"file:global_classpaths.xml\">"+
			"<!ENTITY global_taskdefs SYSTEM \"file:global_taskdefs.xml\">"+
			"<!ENTITY global_targets SYSTEM \"file:global_targets.xml\">"+
			"<!ENTITY properties SYSTEM \"file:properties.xml\">"+
			"]><doc><data><![CDATA[text]]></data></doc>";
		
		XmlDOCTYPEParser docType = new XmlDOCTYPEParser();
		XmlParser parser = new XmlParser();
		parser.addTagParser(docType);
		
		XmlDocument doc = null;
		try{
			doc = parser.parseDocument( xmlData );
		}
		catch(XmlParseException pex)
		{
			fail(pex.getMessage());
		}
		
		String result = doc.toXmlNoBeautify();
		
		assertEquals("Failed to parse DOCTYPE","<doc><data><![CDATA[text]]></data></doc>",result);
		assertEquals("project",docType.getName());
	}
	
	public void testParserReadsDOCTYPEandENTITIES()
	{
		String xmlData="<!DOCTYPE project ["+
			"<!ENTITY global_properties TEST \"file:global_properties.xml\">"+
			"]><doc><data><![CDATA[text]]></data></doc>";
		
		XmlDOCTYPEParser docType = new XmlDOCTYPEParser();
		XmlParser parser = new XmlParser();
		parser.addTagParser(docType);
		
		XmlDocument doc = null;
		try{
			doc = parser.parseDocument( xmlData );
		}
		catch(XmlParseException pex)
		{
			fail(pex.getMessage());
		}
		
		String result = doc.toXmlNoBeautify();
		
		assertEquals("Failed to parse DOCTYPE","<doc><data><![CDATA[text]]></data></doc>",result);
		assertEquals("project",docType.getName());
		assertEquals("file:global_properties.xml",docType.getEntities().get("global_properties"));
		
	}	
}
