package test.org.one.stone.soup.xml;

import org.one.stone.soup.xml.XmlDocument;
import org.one.stone.soup.xml.XmlParseException;
import org.one.stone.soup.xml.XmlParser;

import junit.framework.TestCase;

public class XmlParserENTITYTests extends TestCase {

	public void testParserReadsENTITY()
	{
		String xmlData="<!ENTITY name \"the name\"><doc><data><![CDATA[text]]></data></doc>";
		
		XmlParser parser = new XmlParser();
		
		XmlDocument doc = null;
		try{
			doc = parser.parseDocument( xmlData );
		}
		catch(XmlParseException pex)
		{
			fail(pex.getMessage());
		}
		
		String result = doc.toXmlNoBeautify();
		
		assertEquals("Failed to parse CDATA","<doc><data><![CDATA[text]]></data></doc>",result);
	}
	public void testParserReadsDOCTYPE()
	{
		String xmlData="<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 3.2//EN\"><doc><data><![CDATA[text]]></data></doc>";
		
		XmlParser parser = new XmlParser();
		
		XmlDocument doc = null;
		try{
			doc = parser.parseDocument( xmlData );
		}
		catch(XmlParseException pex)
		{
			fail(pex.getMessage());
		}
		
		String result = doc.toXmlNoBeautify();
		
		assertEquals("Failed to parse CDATA","<doc><data><![CDATA[text]]></data></doc>",result);
	}	
}
