package test.org.one.stone.soup.xml;

import org.one.stone.soup.xml.XmlElement;
import org.one.stone.soup.xml.XmlParseException;
import org.one.stone.soup.xml.XmlParser;

import junit.framework.TestCase;

public class XmlParserTests extends TestCase {

	
	public void testCanParseElementAttribute()
	{
		String data="<name attrib=\"value\"/>";
		
		XmlParser parser = new XmlParser();
		XmlElement result = null;
		try{
			result = parser.parseElement( data );
		}
		catch(XmlParseException xe)
		{
			fail(xe.getMessage());
		}
		
		assertEquals(data,result.toXml().trim());
	}
	
	public void testCanParseElementAttributeWithSpaceAroundEquals()
	{
		String data="<name attrib = \"value\"/>";
		String expectedResult="<name attrib=\"value\"/>";
		
		XmlParser parser = new XmlParser();
		XmlElement result = null;
		try{
			result = parser.parseElement( data );
		}
		catch(XmlParseException xe)
		{
			fail(xe.getMessage());
		}
		
		assertEquals(expectedResult,result.toXml().trim());
	}
	
	public void testCanParseElementAttributeAfterLineBreak()
	{
		String data="<name \nattrib=\"value\">";
		String expectedResult="<name attrib=\"value\"/>";
		
		XmlParser parser = new XmlParser();
		XmlElement result = null;
		try{
			result = parser.parseElement( data );
		}
		catch(XmlParseException xe)
		{
			fail(xe.getMessage());
		}
		
		assertEquals(expectedResult,result.toXml().trim());
	}
}
